/* THIS FILE IS AUTOGENERATED FROM BaseKeyframeTypes.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_BaseKeyframeTypesBinding_h
#define mozilla_dom_BaseKeyframeTypesBinding_h

#include "BaseKeyframeTypesBinding.h"
#include "js/RootingAPI.h"
#include "jspubtd.h"
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/FakeString.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/UnionMember.h"
#include "mozilla/dom/UnionTypes.h"

namespace mozilla {
namespace dom {

struct BaseComputedKeyframeAtoms;
struct BaseKeyframeAtoms;
struct BasePropertyIndexedKeyframeAtoms;
class CompositeOperationOrCompositeOperationSequence;
class DoubleOrNullOrDoubleOrNullSequence;
struct NativePropertyHooks;
class OwningCompositeOperationOrCompositeOperationSequence;
class OwningDoubleOrNullOrDoubleOrNullSequence;
class OwningStringOrStringSequence;
class ProtoAndIfaceCache;
class StringOrStringSequence;

} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {

enum class CompositeOperation : uint8_t {
  Replace,
  Add,
  Accumulate,
  EndGuard_
};

namespace CompositeOperationValues {
extern const EnumEntry strings[4];
} // namespace CompositeOperationValues

bool
ToJSValue(JSContext* aCx, CompositeOperation aArgument, JS::MutableHandle<JS::Value> aValue);


struct BaseKeyframe : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Optional<CompositeOperation> mComposite;
  MOZ_INIT_OUTSIDE_CTOR nsString mEasing;
  MOZ_INIT_OUTSIDE_CTOR Nullable<double> mOffset;
  MOZ_INIT_OUTSIDE_CTOR bool mSimulateComputeValuesFailure;

  BaseKeyframe();

  explicit inline BaseKeyframe(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline BaseKeyframe(const BaseKeyframe& aOther)
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  BaseKeyframe&
  operator=(const BaseKeyframe& aOther);

private:
  static bool
  InitIds(JSContext* cx, BaseKeyframeAtoms* atomsCache);
};

namespace binding_detail {
struct FastBaseKeyframe : public BaseKeyframe
{
  inline FastBaseKeyframe()
    : BaseKeyframe(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


class CompositeOperationOrCompositeOperationSequence
{
  friend class CompositeOperationOrCompositeOperationSequenceArgument;
  enum Type
  {
    eUninitialized,
    eCompositeOperation,
    eCompositeOperationSequence
  };

  union Value
  {
    UnionMember<CompositeOperation > mCompositeOperation;
    UnionMember<binding_detail::AutoSequence<CompositeOperation> > mCompositeOperationSequence;

  };

  Type mType;
  Value mValue;

  CompositeOperationOrCompositeOperationSequence(const CompositeOperationOrCompositeOperationSequence&) = delete;
  CompositeOperationOrCompositeOperationSequence& operator=(const CompositeOperationOrCompositeOperationSequence&) = delete;
public:
  explicit inline CompositeOperationOrCompositeOperationSequence()
    : mType(eUninitialized)
  {
  }

  inline ~CompositeOperationOrCompositeOperationSequence()
  {
    Uninit();
  }

  inline CompositeOperation&
  RawSetAsCompositeOperation()
  {
    if (mType == eCompositeOperation) {
      return mValue.mCompositeOperation.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eCompositeOperation;
    return mValue.mCompositeOperation.SetValue();
  }

  inline CompositeOperation&
  SetAsCompositeOperation()
  {
    if (mType == eCompositeOperation) {
      return mValue.mCompositeOperation.Value();
    }
    Uninit();
    mType = eCompositeOperation;
    return mValue.mCompositeOperation.SetValue();
  }

  inline bool
  IsCompositeOperation() const
  {
    return mType == eCompositeOperation;
  }

  inline CompositeOperation&
  GetAsCompositeOperation()
  {
    MOZ_ASSERT(IsCompositeOperation(), "Wrong type!");
    return mValue.mCompositeOperation.Value();
  }

  inline CompositeOperation
  GetAsCompositeOperation() const
  {
    MOZ_ASSERT(IsCompositeOperation(), "Wrong type!");
    return mValue.mCompositeOperation.Value();
  }

  inline binding_detail::AutoSequence<CompositeOperation>&
  RawSetAsCompositeOperationSequence()
  {
    if (mType == eCompositeOperationSequence) {
      return mValue.mCompositeOperationSequence.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eCompositeOperationSequence;
    return mValue.mCompositeOperationSequence.SetValue();
  }

  inline binding_detail::AutoSequence<CompositeOperation>&
  SetAsCompositeOperationSequence()
  {
    if (mType == eCompositeOperationSequence) {
      return mValue.mCompositeOperationSequence.Value();
    }
    Uninit();
    mType = eCompositeOperationSequence;
    return mValue.mCompositeOperationSequence.SetValue();
  }

  inline bool
  IsCompositeOperationSequence() const
  {
    return mType == eCompositeOperationSequence;
  }

  inline binding_detail::AutoSequence<CompositeOperation>&
  GetAsCompositeOperationSequence()
  {
    MOZ_ASSERT(IsCompositeOperationSequence(), "Wrong type!");
    return mValue.mCompositeOperationSequence.Value();
  }

  inline const Sequence<CompositeOperation>&
  GetAsCompositeOperationSequence() const
  {
    MOZ_ASSERT(IsCompositeOperationSequence(), "Wrong type!");
    return mValue.mCompositeOperationSequence.Value();
  }

  inline void
  Uninit()
  {
    switch (mType) {
      case eUninitialized: {
        break;
      }
      case eCompositeOperation: {
        DestroyCompositeOperation();
        break;
      }
      case eCompositeOperationSequence: {
        DestroyCompositeOperationSequence();
        break;
      }
    }
  }

  bool
  ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const;

private:
  inline void
  DestroyCompositeOperation()
  {
    MOZ_ASSERT(IsCompositeOperation(), "Wrong type!");
    mValue.mCompositeOperation.Destroy();
    mType = eUninitialized;
  }

  inline void
  DestroyCompositeOperationSequence()
  {
    MOZ_ASSERT(IsCompositeOperationSequence(), "Wrong type!");
    mValue.mCompositeOperationSequence.Destroy();
    mType = eUninitialized;
  }
};


class OwningCompositeOperationOrCompositeOperationSequence : public AllOwningUnionBase
{
  friend void ImplCycleCollectionUnlink(OwningCompositeOperationOrCompositeOperationSequence& aUnion);
  enum Type
  {
    eUninitialized,
    eCompositeOperation,
    eCompositeOperationSequence
  };

  union Value
  {
    UnionMember<CompositeOperation > mCompositeOperation;
    UnionMember<Sequence<CompositeOperation> > mCompositeOperationSequence;

  };

  Type mType;
  Value mValue;

public:
  explicit inline OwningCompositeOperationOrCompositeOperationSequence()
    : mType(eUninitialized)
  {
  }

  explicit inline OwningCompositeOperationOrCompositeOperationSequence(const OwningCompositeOperationOrCompositeOperationSequence& aOther)
    : mType(eUninitialized)
  {
    *this = aOther;
  }

  inline ~OwningCompositeOperationOrCompositeOperationSequence()
  {
    Uninit();
  }

  CompositeOperation&
  RawSetAsCompositeOperation();

  CompositeOperation&
  SetAsCompositeOperation();

  bool
  TrySetToCompositeOperation(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  inline bool
  IsCompositeOperation() const
  {
    return mType == eCompositeOperation;
  }

  inline CompositeOperation&
  GetAsCompositeOperation()
  {
    MOZ_ASSERT(IsCompositeOperation(), "Wrong type!");
    return mValue.mCompositeOperation.Value();
  }

  inline CompositeOperation const &
  GetAsCompositeOperation() const
  {
    MOZ_ASSERT(IsCompositeOperation(), "Wrong type!");
    return mValue.mCompositeOperation.Value();
  }

  Sequence<CompositeOperation>&
  RawSetAsCompositeOperationSequence();

  Sequence<CompositeOperation>&
  SetAsCompositeOperationSequence();

  bool
  TrySetToCompositeOperationSequence(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  inline bool
  IsCompositeOperationSequence() const
  {
    return mType == eCompositeOperationSequence;
  }

  inline Sequence<CompositeOperation>&
  GetAsCompositeOperationSequence()
  {
    MOZ_ASSERT(IsCompositeOperationSequence(), "Wrong type!");
    return mValue.mCompositeOperationSequence.Value();
  }

  inline Sequence<CompositeOperation> const &
  GetAsCompositeOperationSequence() const
  {
    MOZ_ASSERT(IsCompositeOperationSequence(), "Wrong type!");
    return mValue.mCompositeOperationSequence.Value();
  }

  void
  Uninit();

  bool
  ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceUnion(JSTracer* trc);

  OwningCompositeOperationOrCompositeOperationSequence&
  operator=(const OwningCompositeOperationOrCompositeOperationSequence& aOther);

private:
  void
  DestroyCompositeOperation();

  void
  DestroyCompositeOperationSequence();
};


class DoubleOrNullOrDoubleOrNullSequence
{
  friend class DoubleOrNullOrDoubleOrNullSequenceArgument;
  enum Type
  {
    eUninitialized,
    eNull,
    eDouble,
    eDoubleOrNullSequence
  };

  union Value
  {
    UnionMember<double > mDouble;
    UnionMember<binding_detail::AutoSequence<Nullable<double>> > mDoubleOrNullSequence;

  };

  Type mType;
  Value mValue;

  DoubleOrNullOrDoubleOrNullSequence(const DoubleOrNullOrDoubleOrNullSequence&) = delete;
  DoubleOrNullOrDoubleOrNullSequence& operator=(const DoubleOrNullOrDoubleOrNullSequence&) = delete;
public:
  explicit inline DoubleOrNullOrDoubleOrNullSequence()
    : mType(eUninitialized)
  {
  }

  inline ~DoubleOrNullOrDoubleOrNullSequence()
  {
    Uninit();
  }

  inline bool
  IsNull() const
  {
    return mType == eNull;
  }

  inline void
  SetNull()
  {
    Uninit();
    mType = eNull;
  }

  inline double&
  RawSetAsDouble()
  {
    if (mType == eDouble) {
      return mValue.mDouble.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eDouble;
    return mValue.mDouble.SetValue();
  }

  inline double&
  SetAsDouble()
  {
    if (mType == eDouble) {
      return mValue.mDouble.Value();
    }
    Uninit();
    mType = eDouble;
    return mValue.mDouble.SetValue();
  }

  inline bool
  IsDouble() const
  {
    return mType == eDouble;
  }

  inline double&
  GetAsDouble()
  {
    MOZ_ASSERT(IsDouble(), "Wrong type!");
    return mValue.mDouble.Value();
  }

  inline double
  GetAsDouble() const
  {
    MOZ_ASSERT(IsDouble(), "Wrong type!");
    return mValue.mDouble.Value();
  }

  inline binding_detail::AutoSequence<Nullable<double>>&
  RawSetAsDoubleOrNullSequence()
  {
    if (mType == eDoubleOrNullSequence) {
      return mValue.mDoubleOrNullSequence.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eDoubleOrNullSequence;
    return mValue.mDoubleOrNullSequence.SetValue();
  }

  inline binding_detail::AutoSequence<Nullable<double>>&
  SetAsDoubleOrNullSequence()
  {
    if (mType == eDoubleOrNullSequence) {
      return mValue.mDoubleOrNullSequence.Value();
    }
    Uninit();
    mType = eDoubleOrNullSequence;
    return mValue.mDoubleOrNullSequence.SetValue();
  }

  inline bool
  IsDoubleOrNullSequence() const
  {
    return mType == eDoubleOrNullSequence;
  }

  inline binding_detail::AutoSequence<Nullable<double>>&
  GetAsDoubleOrNullSequence()
  {
    MOZ_ASSERT(IsDoubleOrNullSequence(), "Wrong type!");
    return mValue.mDoubleOrNullSequence.Value();
  }

  inline const Sequence<Nullable<double>>&
  GetAsDoubleOrNullSequence() const
  {
    MOZ_ASSERT(IsDoubleOrNullSequence(), "Wrong type!");
    return mValue.mDoubleOrNullSequence.Value();
  }

  inline void
  Uninit()
  {
    switch (mType) {
      case eUninitialized: {
        break;
      }
      case eNull: {
        break;
      }
      case eDouble: {
        DestroyDouble();
        break;
      }
      case eDoubleOrNullSequence: {
        DestroyDoubleOrNullSequence();
        break;
      }
    }
  }

  bool
  ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const;

private:
  inline void
  DestroyDouble()
  {
    MOZ_ASSERT(IsDouble(), "Wrong type!");
    mValue.mDouble.Destroy();
    mType = eUninitialized;
  }

  inline void
  DestroyDoubleOrNullSequence()
  {
    MOZ_ASSERT(IsDoubleOrNullSequence(), "Wrong type!");
    mValue.mDoubleOrNullSequence.Destroy();
    mType = eUninitialized;
  }
};


class OwningDoubleOrNullOrDoubleOrNullSequence : public AllOwningUnionBase
{
  friend void ImplCycleCollectionUnlink(OwningDoubleOrNullOrDoubleOrNullSequence& aUnion);
  enum Type
  {
    eUninitialized,
    eNull,
    eDouble,
    eDoubleOrNullSequence
  };

  union Value
  {
    UnionMember<double > mDouble;
    UnionMember<Sequence<Nullable<double>> > mDoubleOrNullSequence;

  };

  Type mType;
  Value mValue;

public:
  explicit inline OwningDoubleOrNullOrDoubleOrNullSequence()
    : mType(eUninitialized)
  {
  }

  explicit inline OwningDoubleOrNullOrDoubleOrNullSequence(const OwningDoubleOrNullOrDoubleOrNullSequence& aOther)
    : mType(eUninitialized)
  {
    *this = aOther;
  }

  inline ~OwningDoubleOrNullOrDoubleOrNullSequence()
  {
    Uninit();
  }

  inline bool
  IsNull() const
  {
    return mType == eNull;
  }

  inline void
  SetNull()
  {
    Uninit();
    mType = eNull;
  }

  double&
  RawSetAsDouble();

  double&
  SetAsDouble();

  bool
  TrySetToDouble(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  inline bool
  IsDouble() const
  {
    return mType == eDouble;
  }

  inline double&
  GetAsDouble()
  {
    MOZ_ASSERT(IsDouble(), "Wrong type!");
    return mValue.mDouble.Value();
  }

  inline double const &
  GetAsDouble() const
  {
    MOZ_ASSERT(IsDouble(), "Wrong type!");
    return mValue.mDouble.Value();
  }

  Sequence<Nullable<double>>&
  RawSetAsDoubleOrNullSequence();

  Sequence<Nullable<double>>&
  SetAsDoubleOrNullSequence();

  bool
  TrySetToDoubleOrNullSequence(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  inline bool
  IsDoubleOrNullSequence() const
  {
    return mType == eDoubleOrNullSequence;
  }

  inline Sequence<Nullable<double>>&
  GetAsDoubleOrNullSequence()
  {
    MOZ_ASSERT(IsDoubleOrNullSequence(), "Wrong type!");
    return mValue.mDoubleOrNullSequence.Value();
  }

  inline Sequence<Nullable<double>> const &
  GetAsDoubleOrNullSequence() const
  {
    MOZ_ASSERT(IsDoubleOrNullSequence(), "Wrong type!");
    return mValue.mDoubleOrNullSequence.Value();
  }

  void
  Uninit();

  bool
  ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceUnion(JSTracer* trc);

  OwningDoubleOrNullOrDoubleOrNullSequence&
  operator=(const OwningDoubleOrNullOrDoubleOrNullSequence& aOther);

private:
  void
  DestroyDouble();

  void
  DestroyDoubleOrNullSequence();
};


struct BaseComputedKeyframe : public BaseKeyframe
{
  MOZ_INIT_OUTSIDE_CTOR Optional<double> mComputedOffset;

  BaseComputedKeyframe();

  explicit inline BaseComputedKeyframe(const FastDictionaryInitializer& )
    : BaseKeyframe(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline BaseComputedKeyframe(const BaseComputedKeyframe& aOther)
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  BaseComputedKeyframe&
  operator=(const BaseComputedKeyframe& aOther);

private:
  static bool
  InitIds(JSContext* cx, BaseComputedKeyframeAtoms* atomsCache);
};

namespace binding_detail {
struct FastBaseComputedKeyframe : public BaseComputedKeyframe
{
  inline FastBaseComputedKeyframe()
    : BaseComputedKeyframe(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct BasePropertyIndexedKeyframe : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR OwningCompositeOperationOrCompositeOperationSequence mComposite;
  MOZ_INIT_OUTSIDE_CTOR OwningStringOrStringSequence mEasing;
  MOZ_INIT_OUTSIDE_CTOR OwningDoubleOrNullOrDoubleOrNullSequence mOffset;

  BasePropertyIndexedKeyframe();

  explicit inline BasePropertyIndexedKeyframe(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline BasePropertyIndexedKeyframe(const BasePropertyIndexedKeyframe& aOther)
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  BasePropertyIndexedKeyframe&
  operator=(const BasePropertyIndexedKeyframe& aOther);

private:
  static bool
  InitIds(JSContext* cx, BasePropertyIndexedKeyframeAtoms* atomsCache);
};

namespace binding_detail {
struct FastBasePropertyIndexedKeyframe : public BasePropertyIndexedKeyframe
{
  inline FastBasePropertyIndexedKeyframe()
    : BasePropertyIndexedKeyframe(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_BaseKeyframeTypesBinding_h
