//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef ClientIPCTypes_h
#define ClientIPCTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "mozilla/TimeStamp.h"
#include "mozilla/dom/ClientIPCUtils.h"
#include "mozilla/dom/DOMTypes.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"
#include "mozilla/dom/IPCServiceWorkerDescriptor.h"
#include "mozilla/ipc/ProtocolTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientSourceConstructorArgs|
//
namespace mozilla {
namespace dom {
class ClientSourceConstructorArgs final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT ClientSourceConstructorArgs() :
        id_(),
        type_(),
        principalInfo_(),
        creationTime_()
    {
    }

    MOZ_IMPLICIT ClientSourceConstructorArgs(
            const nsID& _id,
            const ClientType& _type,
            const PrincipalInfo& _principalInfo,
            const TimeStamp& _creationTime) :
        id_(_id),
        type_(_type),
        principalInfo_(_principalInfo),
        creationTime_(_creationTime)
    {
    }

    bool
    operator==(const ClientSourceConstructorArgs& _o) const;

    bool
    operator!=(const ClientSourceConstructorArgs& _o) const;

    nsID&
    id()
    {
        return id_;
    }
    const nsID&
    id() const
    {
        return id_;
    }

    ClientType&
    type()
    {
        return type_;
    }
    const ClientType&
    type() const
    {
        return type_;
    }

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    TimeStamp&
    creationTime()
    {
        return creationTime_;
    }
    const TimeStamp&
    creationTime() const
    {
        return creationTime_;
    }

private:
    nsID id_;
    ClientType type_;
    PrincipalInfo principalInfo_;
    TimeStamp creationTime_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::ClientSourceConstructorArgs>
{
    typedef mozilla::dom::ClientSourceConstructorArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCClientInfo|
//
namespace mozilla {
namespace dom {
class IPCClientInfo final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT IPCClientInfo() :
        id_(),
        type_(),
        principalInfo_(),
        creationTime_(),
        url_(),
        frameType_()
    {
    }

    MOZ_IMPLICIT IPCClientInfo(
            const nsID& _id,
            const ClientType& _type,
            const PrincipalInfo& _principalInfo,
            const TimeStamp& _creationTime,
            const nsCString& _url,
            const FrameType& _frameType) :
        id_(_id),
        type_(_type),
        principalInfo_(_principalInfo),
        creationTime_(_creationTime),
        url_(_url),
        frameType_(_frameType)
    {
    }

    bool
    operator==(const IPCClientInfo& _o) const;

    bool
    operator!=(const IPCClientInfo& _o) const;

    nsID&
    id()
    {
        return id_;
    }
    const nsID&
    id() const
    {
        return id_;
    }

    ClientType&
    type()
    {
        return type_;
    }
    const ClientType&
    type() const
    {
        return type_;
    }

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    TimeStamp&
    creationTime()
    {
        return creationTime_;
    }
    const TimeStamp&
    creationTime() const
    {
        return creationTime_;
    }

    nsCString&
    url()
    {
        return url_;
    }
    const nsCString&
    url() const
    {
        return url_;
    }

    FrameType&
    frameType()
    {
        return frameType_;
    }
    const FrameType&
    frameType() const
    {
        return frameType_;
    }

private:
    nsID id_;
    ClientType type_;
    PrincipalInfo principalInfo_;
    TimeStamp creationTime_;
    nsCString url_;
    FrameType frameType_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCClientInfo>
{
    typedef mozilla::dom::IPCClientInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCClientWindowState|
//
namespace mozilla {
namespace dom {
class IPCClientWindowState final
{
private:
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT IPCClientWindowState() :
        visibilityState_(),
        lastFocusTime_(),
        focused_()
    {
    }

    MOZ_IMPLICIT IPCClientWindowState(
            const VisibilityState& _visibilityState,
            const TimeStamp& _lastFocusTime,
            const bool& _focused) :
        visibilityState_(_visibilityState),
        lastFocusTime_(_lastFocusTime),
        focused_(_focused)
    {
    }

    bool
    operator==(const IPCClientWindowState& _o) const;

    bool
    operator!=(const IPCClientWindowState& _o) const;

    VisibilityState&
    visibilityState()
    {
        return visibilityState_;
    }
    const VisibilityState&
    visibilityState() const
    {
        return visibilityState_;
    }

    TimeStamp&
    lastFocusTime()
    {
        return lastFocusTime_;
    }
    const TimeStamp&
    lastFocusTime() const
    {
        return lastFocusTime_;
    }

    bool&
    focused()
    {
        return focused_;
    }
    const bool&
    focused() const
    {
        return focused_;
    }

private:
    VisibilityState visibilityState_;
    TimeStamp lastFocusTime_;
    bool focused_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCClientWindowState>
{
    typedef mozilla::dom::IPCClientWindowState paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCClientWorkerState|
//
namespace mozilla {
namespace dom {
class IPCClientWorkerState final
{
private:

public:
    MOZ_IMPLICIT IPCClientWorkerState()
    {
    }

    bool
    operator==(const IPCClientWorkerState& _o) const;

    bool
    operator!=(const IPCClientWorkerState& _o) const;

private:
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCClientWorkerState>
{
    typedef mozilla::dom::IPCClientWorkerState paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCClientState|
//
namespace mozilla {
namespace dom {
class IPCClientState final
{
public:
    enum Type {
        T__None,
        TIPCClientWindowState = 1,
        TIPCClientWorkerState,
        T__Last = TIPCClientWorkerState
    };

private:
    typedef mozilla::dom::IPCClientWindowState IPCClientWindowState;
    typedef mozilla::dom::IPCClientWorkerState IPCClientWorkerState;
    typedef IPCClientWindowState IPCClientWindowState__tdef;
    typedef IPCClientWorkerState IPCClientWorkerState__tdef;

    union Value {
        mozilla::AlignedStorage2<IPCClientWindowState> VIPCClientWindowState;
        mozilla::AlignedStorage2<IPCClientWorkerState> VIPCClientWorkerState;
    };

    IPCClientWindowState*
    ptr_IPCClientWindowState()
    {
        return ((mValue).VIPCClientWindowState).addr();
    }
    const IPCClientWindowState*
    constptr_IPCClientWindowState() const
    {
        return ((mValue).VIPCClientWindowState).addr();
    }
    IPCClientWorkerState*
    ptr_IPCClientWorkerState()
    {
        return ((mValue).VIPCClientWorkerState).addr();
    }
    const IPCClientWorkerState*
    constptr_IPCClientWorkerState() const
    {
        return ((mValue).VIPCClientWorkerState).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCClientState() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCClientState(const IPCClientWindowState& aOther);

    MOZ_IMPLICIT IPCClientState(IPCClientWindowState&& aOther);

    MOZ_IMPLICIT IPCClientState(const IPCClientWorkerState& aOther);

    MOZ_IMPLICIT IPCClientState(IPCClientWorkerState&& aOther);

    MOZ_IMPLICIT IPCClientState(const IPCClientState& aOther);

    MOZ_IMPLICIT IPCClientState(IPCClientState&& aOther);

    ~IPCClientState();

    Type
    type() const
    {
        return mType;
    }

    IPCClientState&
    operator=(const IPCClientWindowState& aRhs);

    IPCClientState&
    operator=(IPCClientWindowState&& aRhs);

    IPCClientState&
    operator=(const IPCClientWorkerState& aRhs);

    IPCClientState&
    operator=(IPCClientWorkerState&& aRhs);

    IPCClientState&
    operator=(const IPCClientState& aRhs);

    IPCClientState&
    operator=(IPCClientState&& aRhs);

    bool
    operator==(const IPCClientWindowState& aRhs) const;

    bool
    operator==(const IPCClientWorkerState& aRhs) const;

    bool
    operator==(const IPCClientState& aRhs) const;

    IPCClientWindowState&
    get_IPCClientWindowState()
    {
        AssertSanity(TIPCClientWindowState);
        return (*(ptr_IPCClientWindowState()));
    }
    const IPCClientWindowState&
    get_IPCClientWindowState() const
    {
        AssertSanity(TIPCClientWindowState);
        return (*(constptr_IPCClientWindowState()));
    }
    void
    get(IPCClientWindowState* aOutValue) const;
    operator IPCClientWindowState&()
    {
        return get_IPCClientWindowState();
    }
    operator const IPCClientWindowState&() const
    {
        return get_IPCClientWindowState();
    }

    IPCClientWorkerState&
    get_IPCClientWorkerState()
    {
        AssertSanity(TIPCClientWorkerState);
        return (*(ptr_IPCClientWorkerState()));
    }
    const IPCClientWorkerState&
    get_IPCClientWorkerState() const
    {
        AssertSanity(TIPCClientWorkerState);
        return (*(constptr_IPCClientWorkerState()));
    }
    void
    get(IPCClientWorkerState* aOutValue) const;
    operator IPCClientWorkerState&()
    {
        return get_IPCClientWorkerState();
    }
    operator const IPCClientWorkerState&() const
    {
        return get_IPCClientWorkerState();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::IPCClientState>
{
    typedef mozilla::dom::IPCClientState paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientOpenWindowArgs|
//
namespace mozilla {
namespace dom {
class ClientOpenWindowArgs final
{
private:

public:
    MOZ_IMPLICIT ClientOpenWindowArgs()
    {
    }

    bool
    operator==(const ClientOpenWindowArgs& _o) const;

    bool
    operator!=(const ClientOpenWindowArgs& _o) const;

private:
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::ClientOpenWindowArgs>
{
    typedef mozilla::dom::ClientOpenWindowArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientOpConstructorArgs|
//
namespace mozilla {
namespace dom {
class ClientOpConstructorArgs final
{
private:

public:
    MOZ_IMPLICIT ClientOpConstructorArgs()
    {
    }

    bool
    operator==(const ClientOpConstructorArgs& _o) const;

    bool
    operator!=(const ClientOpConstructorArgs& _o) const;

private:
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::ClientOpConstructorArgs>
{
    typedef mozilla::dom::ClientOpConstructorArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClientNavigateOpConstructorArgs|
//
namespace mozilla {
namespace dom {
class ClientNavigateOpConstructorArgs final
{
private:

public:
    MOZ_IMPLICIT ClientNavigateOpConstructorArgs()
    {
    }

    bool
    operator==(const ClientNavigateOpConstructorArgs& _o) const;

    bool
    operator!=(const ClientNavigateOpConstructorArgs& _o) const;

private:
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::ClientNavigateOpConstructorArgs>
{
    typedef mozilla::dom::ClientNavigateOpConstructorArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union ClientOpResult|
//
namespace mozilla {
namespace dom {
class ClientOpResult final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        T__Last = Tnsresult
    };

private:
    typedef nsresult nsresult__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT ClientOpResult() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT ClientOpResult(const nsresult& aOther);

    MOZ_IMPLICIT ClientOpResult(nsresult&& aOther);

    MOZ_IMPLICIT ClientOpResult(const ClientOpResult& aOther);

    MOZ_IMPLICIT ClientOpResult(ClientOpResult&& aOther);

    ~ClientOpResult();

    Type
    type() const
    {
        return mType;
    }

    ClientOpResult&
    operator=(const nsresult& aRhs);

    ClientOpResult&
    operator=(nsresult&& aRhs);

    ClientOpResult&
    operator=(const ClientOpResult& aRhs);

    ClientOpResult&
    operator=(ClientOpResult&& aRhs);

    bool
    operator==(const nsresult& aRhs) const;

    bool
    operator==(const ClientOpResult& aRhs) const;

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    void
    get(nsresult* aOutValue) const;
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::ClientOpResult>
{
    typedef mozilla::dom::ClientOpResult paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef ClientIPCTypes_h
